local o = mOnWardrobe

---------------------------------------------------------------
--  Initialization                                                   
---------------------------------------------------------------

o.CURRENT_PAGE = 1

---------------------------------------------------------------
--  Create UI                                          
---------------------------------------------------------------

mOnWD_MainFrame = CreateFrame("FRAME","mOnWD_MainFrame",UIParent,"ButtonFrameTemplate");
mOnWD_MainFrameTitleText:SetText("mOnAr's Wardrobe Helper (v" .. o.version .. ")");
local f = mOnWD_MainFrame;
f:SetHeight(512);
f:SetWidth(384);
f:Hide();
tinsert(UISpecialFrames,"mOnWD_MainFrame");
f:SetFrameStrata("high");
f:SetPoint("CENTER",0,0);
f:SetMovable(true);
f:EnableMouse(true);
f:SetClampedToScreen(true);
f:RegisterForDrag("LeftButton");
f:SetScript("OnDragStart", f.StartMoving)
f:SetScript("OnDragStop", f.StopMovingOrSizing)
SetPortraitToTexture(mOnWD_MainFramePortrait, "Interface\\FriendsFrame\\FriendsFrameScrollIcon");

local f=CreateFrame("FRAME",nil,mOnWD_MainFrame);
mOnWD_MainFrame.ListFrame = f;
f:SetHeight(512);
f:SetWidth(384);
f:EnableMouse(false);
f:SetAllPoints(mOnWD_MainFrame);

local b = CreateFrame("BUTTON","mOnWD_MainFrame_bRefresh",f,"UIPanelButtonTemplate");
f.bRefresh = b;
b:SetPoint("TOPRIGHT",-10,-35);
b:SetText("Refresh Items")
b:SetHeight(25);
b:SetWidth(120);
b:SetScript("OnClick", function()
		if mOnWD_MainFrame.ItemFrame then
			mOnWD_MainFrame.ItemFrame:Hide()
		end
		o.updateMissingVisuals()
	end)

local b = CreateFrame("BUTTON","mOnWD_MainFrame_bCurrentInstance",f,"UIPanelButtonTemplate");
f.bRefresh = b;
b:SetPoint("RIGHT", mOnWD_MainFrame_bRefresh, "LEFT", -10, 0);
b:SetText("Current Instance")
b:SetHeight(25);
b:SetWidth(120);
b:SetScript("OnClick", function()
		o.GUIcurrentInstance()
	end)

local ff = CreateFrame("FRAME",nil,f);
ff:Show();
f.RowFrame = ff;
ff:SetPoint("TOPLEFT",3,-94);
ff:SetWidth(377);
ff:SetHeight(380);

local t = ff:CreateTexture(nil, "BACKGROUND");
ff.BG = t;
t:SetTexture(0,0,0,0.4);
t:SetAllPoints(ff);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColL1 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("TOPLEFT",6,-70);
t:SetTexCoord(0,0.078125,0,0.75);
t:SetWidth(5);
t:SetHeight(24);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColM1 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("LEFT",f.ColL1,"RIGHT");
t:SetTexCoord(0.078125,0.90625,0,0.75);
t:SetWidth(120);
t:SetHeight(24);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColR1 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("LEFT",f.ColM1,"RIGHT");
t:SetTexCoord(0.90625,0.96875,0,0.75);
t:SetWidth(4);
t:SetHeight(24);

local fs = f:CreateFontString(nil, "ARTWORK","GameFontNormalSmall");
f.ColT1 = fs;
fs:SetText("Max / Total Missing");
fs:SetPoint("LEFT",f.ColL1, 10, 0);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColL2 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("Left",f.ColR1,10,0);
t:SetTexCoord(0,0.078125,0,0.75);
t:SetWidth(5);
t:SetHeight(24);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColM2 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("LEFT",f.ColL2,"RIGHT");
t:SetTexCoord(0.078125,0.90625,0,0.75);
t:SetWidth(220);
t:SetHeight(24);

local t = f:CreateTexture(nil, "ARTWORK");
f.ColR2 = t;
t:SetTexture("Interface\\FriendsFrame\\WhoFrame-ColumnTabs");
t:SetPoint("LEFT",f.ColM2,"RIGHT");
t:SetTexCoord(0.90625,0.96875,0,0.75);
t:SetWidth(4);
t:SetHeight(24);

local fs = f:CreateFontString(nil, "ARTWORK","GameFontNormalSmall");
f.ColT2 = fs;
fs:SetText("Instance");
fs:SetPoint("LEFT",f.ColL2, 10, 0);

local function CreateTableRow(parent, rowHeight, N)
  local row = CreateFrame("Button", nil, parent)
  row:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	row.id = N;
  row:SetHeight(rowHeight)
  row:SetPoint("LEFT")
  row:SetPoint("RIGHT")
	row:SetScript("OnClick", function()
			o.GUIselect(row.text2:GetText())
		end);

  local c = row:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
  c:SetHeight(rowHeight)
  c:SetWidth(110 - (2 * 10))
  c:SetJustifyH("LEFT")
  c:SetPoint("LEFT", row, "LEFT", 20, 0)
	c:SetText('');
	row.text1 = c;
	
	local c = row:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
  c:SetHeight(rowHeight)
  c:SetWidth(220 - (2 * 10))
  c:SetJustifyH("LEFT")
  c:SetPoint("LEFT", row.text1, "RIGHT", 2 * 10, 0)
	c:SetText('');
	row.text2 = c;

  return row
end

local fontHeight = select(2, GameFontNormalSmall:GetFont())
local rowHeight = fontHeight + 4
local numRows = math.floor(ff:GetHeight() / rowHeight)
ff.rowHeight = rowHeight
ff.numRows = numRows;
ff.rows = {}

for i=1,numRows do
	local r = CreateTableRow(ff, rowHeight, i)
	if #ff.rows == 0 then
		r:SetPoint("TOP")
	else
		r:SetPoint("TOP", ff.rows[#ff.rows], "BOTTOM")
	end
	table.insert(ff.rows, r)
end

local b = CreateFrame("BUTTON");
f.ButtonPrevPage = b;
b:SetParent(f);
b:SetWidth(32);
b:SetHeight(32);
b:SetPoint("BOTTOMRIGHT","mOnWD_MainFrame",-55,0);
b:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up.bpl");
b:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down.bpl");
b:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled.bpl");
b:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight.bpl","ADD");
b:Disable();
b:SetScript("OnClick", function()
			o.GUImainPage(o.CURRENT_PAGE-1)
	end);
	
local b = CreateFrame("BUTTON");
f.ButtonNextPage = b;
b:SetParent(f);
b:SetWidth(32);
b:SetHeight(32);
b:SetPoint("BOTTOMRIGHT","mOnWD_MainFrame",-20,0);
b:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up.bpl");
b:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down.bpl");
b:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled.bpl");
b:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight.bpl","ADD");
b:SetScript("OnClick", function()
		o.GUImainPage(o.CURRENT_PAGE+1)
	end);

local fs = f:CreateFontString("mOnWD_MainFrame_PageText","OVERLAY","GameFontNormalSmall");
f.PageText = fs;
fs:SetWidth(102);
fs:SetHeight(0);
fs:SetJustifyH("RIGHT");
fs:SetPoint("BOTTOMRIGHT",-99,12);

f:EnableMouseWheel(true)
f:SetScript("OnMouseWheel", function(self, delta)
	if o.CURRENT_PAGE - delta > 0 and o.CURRENT_PAGE - delta < mOnWD_MainFrame.ListFrame.TOTAL_PAGES + 1 then
		o.GUImainPage(o.CURRENT_PAGE - delta)
  	end
end)

local n = CreateFrame("CheckButton", "mOnWD_hideList", mOnWD_MainFrame, "ChatConfigCheckButtonTemplate")
mOnWD_MainFrame.hideList = n
n:SetPoint("BOTTOMLEFT", mOnWD_MainFrame, 5, 2)
mOnWD_hideListText:SetText("Hide List when openning Instance")
n:SetScript("OnClick", function()
		if n:GetChecked() then
			mOnWDSave.hideList = true
		else
			mOnWDSave.hideList = false
		end
	end);

---------------------------------------------------------------
--  Methods                                              
---------------------------------------------------------------

o.GUImainPage = function(N)
	local ordered_keys = {}

	for k in pairs(o.instances) do
	    table.insert(ordered_keys, k)
	end	
	table.sort(ordered_keys)

	mOnWD_MainFrame.ListFrame.TOTAL_PAGES = math.ceil((#ordered_keys+1) / 27);
	if mOnWD_MainFrame.ListFrame.TOTAL_PAGES == 0 then mOnWD_MainFrame.ListFrame.TOTAL_PAGES = 1 end
	o.CURRENT_PAGE = N;
	mOnWD_MainFrame.ListFrame.PageText:SetText("Page " .. N);
	if N == 1 then
		mOnWD_MainFrame.ListFrame.ButtonPrevPage:Disable();
	else
		mOnWD_MainFrame.ListFrame.ButtonPrevPage:Enable();
	end
	if N == mOnWD_MainFrame.ListFrame.TOTAL_PAGES then
		mOnWD_MainFrame.ListFrame.ButtonNextPage:Disable();
	else
		mOnWD_MainFrame.ListFrame.ButtonNextPage:Enable();
	end
	
	local FirstN = (N-1)*27;
	for i=1,27 do
		local index = i+FirstN
		if o.instances[ordered_keys[index]]~=nil then
			local missing = 0
			local total = 0
			for k, v in pairs(o.instances[ordered_keys[index]]) do
				local current = 0
				for k1, v1 in pairs(v) do
					current = current + #v1
				end
				missing = math.max(missing, current)
				total = total + current
			end 
			if mOnWD_MainFrame and mOnWD_MainFrame.ListFrame and mOnWD_MainFrame.ListFrame.RowFrame and mOnWD_MainFrame.ListFrame.RowFrame.rows and
			mOnWD_MainFrame.ListFrame.RowFrame.rows[i] and mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text1 and mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text2 then
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i]:Enable();
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text1:SetText(missing .. " / " .. total);
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text2:SetText(ordered_keys[index]);
			end
		else
			if mOnWD_MainFrame and mOnWD_MainFrame.ListFrame and mOnWD_MainFrame.ListFrame.RowFrame and mOnWD_MainFrame.ListFrame.RowFrame.rows and
			mOnWD_MainFrame.ListFrame.RowFrame.rows[i] and mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text1 and mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text2 then
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text1:SetText("");
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i].text2:SetText("");
				mOnWD_MainFrame.ListFrame.RowFrame.rows[i]:Disable();
			end
		end
	end
end;

o.GUIselect = function(instance)
	o.GUIshowItems(instance)
end

